<template>
    <div>
        <section class="hero">
            <div class="hero-body">
                <div class="container">
                    <h1 class="title" @click="toggleSource">
                        {{ $t('search.title') }}
                    </h1>
                    <h2 class="subtitle">
                        {{ $t('search.description') }}
                    </h2>
                </div>
            </div>
            <div class="hero-foot">
                <div class="container">
                    <div class="field has-addons">
                        <div class="control has-icons-left is-expanded" v-bind:class="{ 'is-loading':loading }">
                            <input @keyup.enter="triggerSearch" v-model="search" type="text" :placeholder="$t('search.placeholder')" class="input is-primary">
                            <span class="icon is-small is-left">
                                <font-awesome-icon :icon="['fas', 'search']"></font-awesome-icon>
                            </span>
                        </div>
                        <div class="control">
                            <span class="select is-primary">
                                <select :aria-label="$t('search.aria.sort')" v-model="sort">
                                    <option value="likes" selected>{{ $t('search.sort.most_likes') }}</option>
                                    <option value="az">{{ $t('search.sort.a_z') }}</option>
                                    <option value="likes_asc">{{ $t('search.sort.least_likes') }}</option>
                                </select>
                            </span>
                        </div>
                    </div>
                </div>
                <br>
            </div>
        </section>
        <br>
        <div class="container">
            <pagination :page="page" :last-page="lastPage" @page="setPage"></pagination>
            <Kara v-for="kara in karas[page]" :key="kara.id" :kara="kara" :showSource="source"></Kara>
            <div class="box" v-if="page === lastPage">
                <article class="media">
                    <div class="media-content">
                        <h4 class="title is-4 content">
                            {{ $t('kara.last.text') }}
                        </h4>
                    </div>
                    <div class="media-right">
                        <button class="button is-success" @click="$parent.$emit('suggestion')">{{ $t('kara.last.btn') }}</button>
                    </div>
                </article>
            </div>
            <pagination :page="page" :last-page="lastPage" @page="setPage"></pagination>
        </div>
        <first-time-modal></first-time-modal>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue';
    // @ts-ignore: WebStorm linter is complaining, please don't
    import Kara from '~/components/Kara.vue';
    // @ts-ignore: again
    import FirstTimeModal from "~/components/FirstTimeModal.vue";
    // @ts-ignore: again²
    import Pagination from "~/components/Pagination.vue";
    import { karasStore } from "~/store";

    export default Vue.extend({
        data() {
            return {
                loading: true,
                page: 1,
                lastPage: 1,
                karas: {},
                search: '',
                clock: -1,
                sort: 'likes',
                source: false
            }
        },

        components: {
            Kara,
            FirstTimeModal,
            Pagination
        },

        methods: {
            refreshStore() {
                this.karas = karasStore.karas;
                this.lastPage = karasStore.lastPage;
            },
            refreshURL() {
                this.$router.push({query: {page: this.page.toString(), q: this.search, sort: this.sort}});
            },
            async fetchPage(page: number, silent: boolean = false) {
                if (!silent) this.loading = true;
                if (!karasStore.karas[page] || !silent) {
                    let res = await this.$axios.get(`${process.env.APP_URL}/api/karas`, {
                        params: {
                            page,
                            q: this.search ? this.search:undefined,
                            sort: this.sort
                        }
                    });
                    karasStore.setPage([page, res.data.data]);
                    // Due to an Eloquent ORM bug, the total count is available only on first page.
                    if (page === 1) karasStore.setLastPage(res.data.last_page);
                }
                if (!silent) {
                    this.refreshURL();
                    this.loading = false;
                }
                this.refreshStore();
            },
            triggerSearch() {
                // reset store
                window.clearTimeout(this.clock);
                karasStore.clearStore();
                if (this.page === 1) this.fetchPage(1);
                else this.page = 1;
                this.clock = -1;
                return;
            },
            searchClock() {
                if (this.clock !== -1) return;
                this.clock = window.setTimeout(this.triggerSearch, 2500);
            },
            toggleSource() {
                this.source = !this.source;
            },
            setPage(e: number) {
                this.page = e;
            }
        },

        mounted() {
            this.$nextTick(() => {
                this.$nuxt.$loading.start();
            });
            this.fetchPage(this.page);
        },

        created() {
            if (typeof this.$route.query.q === 'string') this.search = this.$route.query.q;
            if (typeof this.$route.query.sort === 'string') this.sort = this.$route.query.sort;
            if (typeof this.$route.query.page === 'string') this.page = parseInt(this.$route.query.page);
        },

        watch: {
            loading(now, _old) {
                if (now) this.$nuxt.$loading.start();
                else this.$nuxt.$loading.finish();
            },
            page(now, _old) {
                this.fetchPage(now);
                // sanity check
                if (now > this.lastPage) {
                    this.fetchPage(1, true); // Fetch silently (without swithcing page) the first page to get total count
                }
            },
            search(now, _old) {
                if (this.searchClock) this.searchClock();
                this.refreshURL();
            },
            sort(now, _old) {
                karasStore.clearStore();
                if (this.page === 1) this.fetchPage(1);
                else this.page = 1;
            }
        }
    })
</script>
